/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ConversationParamsTranslateRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConversationParamsTranslateRequest{}

// ConversationParamsTranslateRequest struct for ConversationParamsTranslateRequest
type ConversationParamsTranslateRequest struct {
	Params []string `json:"params"`
	Context *SendMessageContext `json:"context,omitempty"`
}

// NewConversationParamsTranslateRequest instantiates a new ConversationParamsTranslateRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversationParamsTranslateRequest(params []string) *ConversationParamsTranslateRequest {
	this := ConversationParamsTranslateRequest{}
	this.Params = params
	return &this
}

// NewConversationParamsTranslateRequestWithDefaults instantiates a new ConversationParamsTranslateRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationParamsTranslateRequestWithDefaults() *ConversationParamsTranslateRequest {
	this := ConversationParamsTranslateRequest{}
	return &this
}

// GetParams returns the Params field value
func (o *ConversationParamsTranslateRequest) GetParams() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Params
}

// GetParamsOk returns a tuple with the Params field value
// and a boolean to check if the value has been set.
func (o *ConversationParamsTranslateRequest) GetParamsOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Params, true
}

// SetParams sets field value
func (o *ConversationParamsTranslateRequest) SetParams(v []string) {
	o.Params = v
}

// GetContext returns the Context field value if set, zero value otherwise.
func (o *ConversationParamsTranslateRequest) GetContext() SendMessageContext {
	if o == nil || IsNil(o.Context) {
		var ret SendMessageContext
		return ret
	}
	return *o.Context
}

// GetContextOk returns a tuple with the Context field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationParamsTranslateRequest) GetContextOk() (*SendMessageContext, bool) {
	if o == nil || IsNil(o.Context) {
		return nil, false
	}
	return o.Context, true
}

// HasContext returns a boolean if a field has been set.
func (o *ConversationParamsTranslateRequest) HasContext() bool {
	if o != nil && !IsNil(o.Context) {
		return true
	}

	return false
}

// SetContext gets a reference to the given SendMessageContext and assigns it to the Context field.
func (o *ConversationParamsTranslateRequest) SetContext(v SendMessageContext) {
	o.Context = &v
}

func (o ConversationParamsTranslateRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConversationParamsTranslateRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["params"] = o.Params
	if !IsNil(o.Context) {
		toSerialize["context"] = o.Context
	}
	return toSerialize, nil
}

type NullableConversationParamsTranslateRequest struct {
	value *ConversationParamsTranslateRequest
	isSet bool
}

func (v NullableConversationParamsTranslateRequest) Get() *ConversationParamsTranslateRequest {
	return v.value
}

func (v *NullableConversationParamsTranslateRequest) Set(val *ConversationParamsTranslateRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableConversationParamsTranslateRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableConversationParamsTranslateRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversationParamsTranslateRequest(val *ConversationParamsTranslateRequest) *NullableConversationParamsTranslateRequest {
	return &NullableConversationParamsTranslateRequest{value: val, isSet: true}
}

func (v NullableConversationParamsTranslateRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversationParamsTranslateRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


